namespace ttrss_co_client.tasks;

using System.Linq;
using System.Diagnostics;
using ttrss_co_client.ttrss;
using ttrss_co_client.ttrss.datastructures;
using System.Threading.Tasks;
using System;

public class ChatMessage : Phase2Task
{
    public static string ChatScript { get; set; }
    public override string TaskName => "chatmessage";

    public override async Task<Tuple<TaskStatus, WorkOrder>> ActOn(WorkOrder workOrder)
    {
        await Process.Start(ChatScript,
            workOrder.data["chatmessage"] +
            (await TtrssClient.GetArticles(workOrder.articleId)).First().feed_title +
            "; " +
            (await TtrssClient.GetArticles(workOrder.articleId)).First().title
        ).WaitForExitAsync();
        return new Tuple<TaskStatus, WorkOrder>(TaskStatus.Done, workOrder);
    }
}