using System.Diagnostics;
using ttrss_co_client.ttrss;
using ttrss_co_client.ttrss.datastructures;

namespace ttrss_co_client.tasks
{
    ///<summary>download from YT</summary>
    public class StandardDL : Phase1Task
    {
        public override string TaskName => "dl";
        public override async Task<WorkOrder> ActOn(Headline headline, IEnumerable<Label> labelsWRTArticle)
        {
            Console.WriteLine($"    standard download: {headline.link.ToString()}");

            var myGuid = Guid.NewGuid().ToString();
            var toReturn = new WorkOrder()
            {
                articleId = headline.id,
                Phase2TaskList = new Dictionary<int, string>(),
                data = new Dictionary<string, string>(),
                guid = Guid.Parse(myGuid)
            };

            toReturn.Phase2TaskList[0] = "yt-dlp";
            toReturn.data["ytdlp-link"] = headline.link.ToString();

            toReturn.Phase2TaskList[1] = "convert";
            toReturn.data["conversion-target"] = ".mp4";

            if(headline.link.Host.EndsWith("youtube.com"))
            {
                toReturn.Phase2TaskList[2] = "sponsorblock";
            }

            toReturn.Phase2TaskList[3] = "filemovePublish";
            toReturn.data["publish-target"] = $"{Conf.OnDoneCopy}/recent episodes/";

            toReturn.Phase2TaskList[4] = "markread";

            toReturn.Phase2TaskList[5] = "chatmessage";
            toReturn.data["chatmessage"] = "new video from ";

            await TtrssClient.SetArticleLabel(labelsWRTArticle.First(l => l.caption?.ToLower() == this.TriggerLabel.ToLower()).id, false, headline.id);
            Console.WriteLine($"    {headline.title}: download trigger label removed");

            return toReturn;
        }
    }
}